
PROCEDURE BCDToBin
;Converts a 3 digit BCD value to 8 Bit Binary
;At entry R1 points to the LSByte of a packed BCD string
;At exit A has the result
; Carry is set if overflow has occurred
; DESTROYS R4,R5,R6,R3
; Point at most significant digitpair
; R1 = R1 + #digitpairs - 1
;
  MOV     A,R1
  ADD     A,#1
  MOV     R1,A
  MOV     R3,#2
  CLR     A
  MOV     R4,A
:BCDLP1:
  CALL    MUL10:
  JC      CONVERSIONERROR:
  MOV     R5,A
  MOV     A,@R1
  SWAP    A
  ANL     A,#0FH
  ADD     A,R5
  XCH     A,R4
  ADDC    A,#0
  XCH     A,R4
  JC      CONVERSIONERROR:
  CALL    MUL10:
  JC      CONVERSIONERROR:
  MOV     R5,A
  MOV     A,@R1
  ANL     A,#0FH
  ADD     A,R5
  XCH     A,R4
  ADDC    A,#0
  XCH     A,R4
  JC      CONVERSIONERROR:
  DEC     R1
  DJNZ    R3,BCDLP1:
:CONVERSIONERROR:
EndProc ; C cleared normal return

PROCEDURE MUL10:
; Utility to multiply BIN by 10
  MOV     R5,A
  XCH     A,R4
  MOV     R6,A
  XCH     A,R4
  CLR     C
  RLC     A
  XCH     A,R4
  RLC     A
  XCH     A,R4
  JC      MUL10ERROR:
  RLC     A
  XCH     A,R4
  RLC     A
  XCH     A,R4
  JC      MUL10ERROR:
  ADD     A,R5
  XCH     A,R4
  ADDC    A,R6
  XCH     A,R4
  JC      MUL10ERROR:
  RLC     A
  XCH     A,R4
  RLC     A
  XCH     A,R4
:MUL10ERROR:
EndProc ; C set if error on return
